﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.Linq;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.datasource = OrderRepository.GetAllRecords();
            var categories= new NorthwindDataContext().Products.Select(ds => ds.CategoryID).Distinct().ToList();
            List<object> list = new List<object>();
            foreach(var item in categories){
                list.Add(new {text = item, value = item});
            }
            ViewBag.dropdown = list;
            return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            DataOperations opt = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                foreach (var temp in dm.Sorted)
                    temp.Direction = dm.Sorted[0].Direction == "ascending" ? "Ascending" : "Descending";

                DataSource = opt.PerformSorting(DataSource, dm.Sorted);

            }

            var count = DataSource.AsQueryable().Count();
            //Paging
            DataSource = opt.PerformSkip(DataSource, dm.Skip);
            DataSource = opt.PerformTake(DataSource, dm.Take);
            return Json(new { result = DataSource, count = count}, JsonRequestBehavior.AllowGet);
        }
        public ActionResult CustomAction(DataManager dm)
        {
            return null;
        }
        public void RowDetails(int id)
        {

        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}